// O[o֐
static BOOL     MainInit(LPSTR lpCmdLine);
static BOOL     MainExit();
static int      MainLoop();
static LRESULT  CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
static BOOL     CALLBACK DlgProc(HWND hW, UINT WM, WPARAM wp, LPARAM lp);

static BOOL CCSetWindowClass(HINSTANCE hInst, char* ClassName, HICON hIcon);    // EBhENX̓o^
static HWND CCCreateWindow(HINSTANCE hInst, CREATESTRUCT &cs, RECT *prcMargin); // EBhE̐

//--------------------------------------------------------------------------------
// O[oϐ
//--------------------------------------------------------------------------------
typedef struct tag_strGLOBALVALUE
{
    HANDLE          hMutex;             // dNh~p̃nh
} strGLOBALVALUE;

static strGLOBALVALUE   global_value;

//--------------------------------------------------------------------------------
// WinMain()
//--------------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmdLine, int nCmdShow )
{
    int err_code = -1;

    if (CCore::s_pCore == NULL) return err_code;
    
    // CX^Xnh̓o^
    CCore::s_pCore->hInst = hInst;
    CCore::s_pCore->m_param.cs.hInstance = hInst;

    // 
    if (MainInit(lpCmdLine)) {
        // C[v
        err_code = MainLoop();
    }

    // I
    MainExit();

    return err_code;
}

//--------------------------------------------------------------------------------
// C[`
//--------------------------------------------------------------------------------
BOOL MainInit(LPSTR lpCmdLine)
{
    char str[_MAX_PATH];
    char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
    CCore* pCore = CCore::s_pCore;

    // fBNg̎擾
    GetModuleFileName(NULL, str, _MAX_PATH);
    _splitpath(str, drive, dir, fname, ext);
    wsprintf(pCore->m_mydir, "%s%s", drive, dir);

    // Init()̌Ăяo
    if (!pCore->Init(lpCmdLine)) return FALSE;

    // dÑ`FbN
    global_value.hMutex = CreateMutex(NULL, TRUE, pCore->m_param.strClassName); // ~[ebNX쐬
    if (GetLastError() == ERROR_ALREADY_EXISTS) return FALSE;                   // ɍ쐬ĂI

    // EBhE̍쐬
    CCSetWindowClass(pCore->hInst, pCore->m_param.strClassName, pCore->m_param.hIcon);          // EBhENX̓o^
    pCore->hWnd = CCCreateWindow(pCore->hInst, pCore->m_param.cs, &(pCore->m_param.rcMargins)); // EBhE̍쐬
    if (pCore->hWnd == NULL) return FALSE;                                                      // EBhE쐬sȂI

    // window̕\
    ShowWindow(pCore->hWnd, SW_SHOW);
    UpdateWindow(pCore->hWnd);

    return TRUE;
}

BOOL MainLoop()
{
    BOOL    ExitLoop = FALSE;   // bZ[W[vEoptO
    MSG     msg;                // EBhEbZ[W
    DWORD   tm;                 // ݂̎
    DWORD   ptm;                // ORun()Ă񂾎

    // bZ[W[v
    ptm = timeGetTime();                    // ԃX^bNɌ݂̎ԂL
    while (!ExitLoop)
    {
        if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
            // I߂ȂLoopEo
            if (msg.message==WM_QUIT) {
                ExitLoop = TRUE;
            }
            // EBhEvV[Wɏn
            if (!TranslateAccelerator(CCore::s_pCore->hWnd, CCore::s_pCore->hAccel, &msg)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        }

        // ref_interval == 0 ȂCRun()͌ĂяoȂD
        if (CCore::s_pCore->m_param.ref_interval == 0) {
            if (!CCore::s_pCore->Idle()) PostQuitMessage(0);
        } else {
            tm = timeGetTime();                                     // ݎԂ̎擾
            if (tm - ptm >= CCore::s_pCore->m_param.ref_interval) {
                // tbV[g𒴂RunĂяo
                CCore::s_pCore->m_iFPS = 1000/(tm - ptm);           // FPŠvZ
                ptm = tm;
                if (!CCore::s_pCore->Run()) PostQuitMessage(0);     // Run()̌Ăяo
            } else {
                if (!CCore::s_pCore->Idle()) PostQuitMessage(0);    // Idol()̌Ăяo
            }
        }
    }

    return msg.wParam;
}

BOOL MainExit()
{
    // ~[ebNX̏I
    ReleaseMutex(global_value.hMutex);
    CloseHandle(global_value.hMutex);

    return CCore::s_pCore->Exit();              // Exit()̌Ăяo
}

//--------------------------------------------------------------------------------
// EBhE⏕
//--------------------------------------------------------------------------------
BOOL CCSetWindowClass(HINSTANCE hInst, char* ClassName, HICON hIcon)
{
    WNDCLASSEX wcex;

    // window Class\̂ݒ
    wcex.cbSize = sizeof(WNDCLASSEX);
    wcex.style = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc = (WNDPROC)WndProc;
    wcex.cbClsExtra = 0;
    wcex.cbWndExtra = 0;
    wcex.hInstance = hInst;
    wcex.hIcon = hIcon;
    wcex.hCursor = LoadCursor(NULL,IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName = NULL;
    wcex.lpszClassName = ClassName;
    wcex.hIconSm = hIcon;
    
    // window Classo^
    RegisterClassEx(&wcex);

    return TRUE;
}

HWND CCCreateWindow(HINSTANCE hInst, CREATESTRUCT &cs, RECT *prcMargin)
{
    HWND    hWnd;
    RECT    rc;

    // csɂ̓NCAg̑傫ĂCEBhȆ傫vZ
    SetRect(&rc, 0, 0, cs.cx, cs.cy);
    AdjustWindowRectEx(&rc, cs.style, (cs.hMenu!=NULL), cs.dwExStyle);
    // EChẼVXeGȂ傫tZ
    if (prcMargin!=NULL) {
        prcMargin->left = -rc.left;
        prcMargin->right = rc.right - cs.cx;
        prcMargin->top = -rc.top;
        prcMargin->bottom = rc.bottom - cs.cy;
    }
    // EBhE̍쐬
    hWnd = CreateWindowEx(cs.dwExStyle, cs.lpszClass, cs.lpszName, cs.style, 
                          cs.x, cs.y, rc.right-rc.left, rc.bottom-rc.top, 
                          cs.hwndParent, cs.hMenu, cs.hInstance, cs.lpCreateParams);

    return hWnd;
}

//--------------------------------------------------------------------------------
// EBhEvV[W
//--------------------------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hWnd, UINT WM, WPARAM wParam, LPARAM lParam)
{
    // CCoreɃbZ[Wn
    if (WM == WM_DESTROY) PostQuitMessage(0);
    if (CCore::s_pCore->Proc(hWnd, WM, wParam, lParam)) return 0;
    // Ȃ΁CDefProc()ɏn
    return DefWindowProc(hWnd, WM, wParam, lParam);
}

// _CAOp
BOOL CALLBACK DlgProc(HWND hW, UINT WM, WPARAM wp, LPARAM lp)
{
    return CCore::s_pCore->ProcDlg(hW, WM, wp, lp);
}

//--------------------------------------------------------------------------------
// ̑
//--------------------------------------------------------------------------------
void DrawRect(HDC dc, int x, int y, int cx, int cy, DWORD col)
{
    static HBRUSH hb;
    static RECT col_rc;

    hb = CreateSolidBrush(col);
    col_rc.left = x;
    col_rc.right = x+cx;
    col_rc.top = y;
    col_rc.bottom = y+cy;
    FillRect(dc, &col_rc, hb);

    DeleteObject(hb);
}

void DrawFrameRect(HDC dc, int x, int y, int cx, int cy, DWORD col)
{
    static HBRUSH hb;
    static RECT col_rc;

    hb = CreateSolidBrush(col);
    col_rc.left = x;
    col_rc.right = x+cx;
    col_rc.top = y;
    col_rc.bottom = y+cy;
    FrameRect(dc, &col_rc, hb);

    DeleteObject(hb);
}
